#ifndef ORGANIZEDLIST_H
#define ORGANIZEDLIST_H

#include <vector>

template<class T>
class TidyList
{
	private:
    typedef std::vector<T>::iterator Iterator;
		std::vector<T> v_;

  public:
    typedef std::vector<T>::size_type size_type;
    typedef T element_type;
		TidyList(){}
		~TidyList(){}
		
		size_type Add(const T& t)
    {
    	v_.push_back(t);
      return v_.size();
    }
		size_type Remove(size_type index)
		{
			if(index<v_.size())
			{
        Iterator it=v_.begin();
  			std::advance(it,index);
  			v_.erase(it);
      }
			return v_.size();
  	}
		void MoveUp(size_type index)
		{
      if(index==0 || index>=v_.size())return;
      Iterator current=v_.begin();
      std::advance(current,index);
      Iterator previous=current--;
      std::swap(*current,*previous);
  	}
		void MoveDown(size_type index)
		{
			if(index>=v_.size()-1)return;
			Iterator current=v_.begin();
      std::advance(current,index);
      Iterator next=current++;
      std::swap(*current,*next);
		}
		size_type Insert(size_type position,const T& t)
		{
      if(position<v_.size())
			{
        Iterator it=v_.begin();
  			std::advance(it,position);
  			v_.insert(it,t);
      }
		  return v_.size();
    }
		const T& Get(size_type index)const{return v_.at(index);}
		size_type Count()const{return v_.size();}
		//I use iterator and std::advance to be container independent instead
		//of simply return v_[index];
    T& operator[](size_type index)
    {
      Iterator it=v_.begin();
      std::advance(it,index);
      return *it;
    }
    const T& operator[](size_type index)const
    {
      Iterator it=v_.begin();
      std::advance(it,index);
      return *it;
    }
};
#endif