/*---------------------------------------------------------------------------
Program :	SysTray.h	Version 1.0
		TSysTray Component for BCB1
Author :	Michel Leunen
Email :		michel@leunen.com
Date :		21/07/1998
Description :	Component for Borland C++ Builder V1 that places an icon in
		the Systray (near the clock).
*/
//---------------------------------------------------------------------------
#ifndef SysTrayH
#define SysTrayH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>

#define ICON_ID 		WM_USER+1
#define TWMNOTIFYICON	WM_USER+2
//---------------------------------------------------------------------------
class PACKAGE TSysTray : public TComponent
{
private:
	  TPopupMenu		*FPopupMenu;
    Graphics::TIcon		*FIcon;
    AnsiString		FTrayHint;
    HWND			WndHandle;				//pointer to main window
    void			*DefProc;               //pointer to old message proc
    void			*WndProcInstance;		//pointer to new message proc

    void __fastcall SetIcon(TIcon *AIcon);
    void __fastcall SetTrayHint(AnsiString ATrayHint);
    void __fastcall SetPopupMenu(TPopupMenu *APopupMenu);

protected:
	//WndProc subclassed
	MESSAGE void __fastcall SubWndProc(Messages::TMessage &Message);

public:
    __fastcall TSysTray(TComponent* Owner);
    __fastcall ~TSysTray();
    void __fastcall AddIcon();
    void __fastcall RemoveIcon();
    void __fastcall ModifyIcon();

__published:
    __property TPopupMenu *PopupMenu = {read=FPopupMenu, write=SetPopupMenu};
    __property TIcon *Icon = {read=FIcon, write=SetIcon};
    __property AnsiString TrayHint = {read=FTrayHint, write=SetTrayHint};

};
//---------------------------------------------------------------------------
#endif
